<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan.parser &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan.parser</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.mulcan.parser</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to generate and get the output of a parser.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">List</span><span class="p">,</span> <span class="n">Dict</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span>
<span class="kn">import</span> <span class="nn">argparse</span>
<span class="kn">from</span> <span class="nn">lib.inout.parser</span> <span class="kn">import</span> <span class="n">add_switch</span><span class="p">,</span> <span class="n">add_arguments_from_dict</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.definition.strategy</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">dict_parser_arguments</span> <span class="k">as</span> <span class="n">dict_parser_cum_strat_arguments</span>
<span class="p">)</span>

<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">paths</span>

<span class="c1">#: Dictionnary of predefined parser arguments</span>
<span class="n">dict_predefined_parse_args</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s2">&quot;indir&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;i&#39;</span><span class="p">,</span> <span class="s1">&#39;indir&#39;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">default_indir</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;path to the output directory of JSON/PNG/PDF/PICKLE files&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;inpath&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;i&#39;</span><span class="p">,</span> <span class="s2">&quot;inpath&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;path to the input ROOT file&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;outpath&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="s2">&quot;outpath&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;path to the output ROOT file&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;outpath_opt&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="s2">&quot;outpath&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
             <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;path to the output ROOT file&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;preselectiondir&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;p&#39;</span><span class="p">,</span> <span class="s1">&#39;preselectiondir&#39;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">default_preselectiondir</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Path to the directory of the preselected ROOT files&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;outdir&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="s1">&#39;outdir&#39;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">default_outdir</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;path to the output directory of JSON/PNG/PDF/PICKLE files&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;sample_type&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;s&#39;</span><span class="p">,</span> <span class="s1">&#39;sample_type&#39;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">LIST_SAMPLE_TYPES</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span>
             <span class="n">choices</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">LIST_SAMPLE_TYPES</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Type of sample&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;year_opt&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;y&#39;</span><span class="p">,</span> <span class="s1">&#39;year&#39;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">choices</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">LIST_YEARS</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Year. If not given, all the years are taken&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;year&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;y&#39;</span><span class="p">,</span> <span class="s1">&#39;year&#39;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">choices</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">LIST_YEARS</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Year&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;ffmodel&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;f&#39;</span><span class="p">,</span> <span class="s2">&quot;ffmodel&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="s2">&quot;CLN&quot;</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
             <span class="n">choices</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">LIST_FFMODELS</span><span class="p">,</span> <span class="n">help</span><span class="o">=</span><span class="s2">&quot;FF model for signal&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;mulcan&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;m&#39;</span><span class="p">,</span> <span class="s2">&quot;mulcan&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">default</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">nargs</span><span class="o">=</span><span class="s1">&#39;?&#39;</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="p">(</span><span class="s2">&quot;Relative output directory that depends on how &quot;</span>
                   <span class="s2">&quot;multiple candidates are handled&quot;</span><span class="p">))</span>
    <span class="p">],</span>
    <span class="s2">&quot;flavour&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;f&#39;</span><span class="p">,</span> <span class="s2">&quot;flavour&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span> <span class="n">choices</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">LIST_FLAVOURS</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Which flavour to analyse&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;tree_name&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;t&#39;</span><span class="p">,</span> <span class="s2">&quot;tree_name&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">required</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Tree name in the input and output ROOT files&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;eosdir&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;d&#39;</span><span class="p">,</span> <span class="s2">&quot;eosdir&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">default</span><span class="o">=</span><span class="n">paths</span><span class="o">.</span><span class="n">eosdir</span><span class="p">,</span> <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
             <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Path to the main EOS directory&quot;</span><span class="p">)</span>
    <span class="p">],</span>
    <span class="s2">&quot;noplot&quot;</span><span class="p">:</span> <span class="p">[</span>
        <span class="p">(</span><span class="s1">&#39;np&#39;</span><span class="p">,</span> <span class="s2">&quot;noplot&quot;</span><span class="p">),</span>
        <span class="nb">dict</span><span class="p">(</span><span class="n">help</span><span class="o">=</span><span class="s2">&quot;Do not produce any plots&quot;</span><span class="p">,</span>
             <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">)</span>
    <span class="p">]</span>
<span class="p">}</span>
<span class="n">dict_predefined_parse_args</span> <span class="o">=</span> <span class="p">{</span>
    <span class="o">**</span><span class="n">dict_predefined_parse_args</span><span class="p">,</span>
    <span class="o">**</span><span class="n">dict_parser_cum_strat_arguments</span>
<span class="p">}</span>


<div class="viewcode-block" id="get_result_gen_parser"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.parser.get_result_gen_parser">[docs]</a><span class="k">def</span> <span class="nf">get_result_gen_parser</span><span class="p">(</span>
    <span class="n">description</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span>
    <span class="n">list_arguments</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">dict_arguments</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Dict</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">str</span><span class="p">]],</span> <span class="nb">dict</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="n">switches</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">List</span><span class="p">[</span><span class="nb">dict</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
<span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Generate a parser and return its result.</span>

<span class="sd">    Args:</span>
<span class="sd">        description (str): description of the script that uses the parser</span>
<span class="sd">        list_arguments (List[str]): list of predefined arguments in the</span>
<span class="sd">            dictionnary :py:mod:`dict_predefined_arguments``</span>
<span class="sd">        switches (List[dict]): List of dictionnary, each dictionnary</span>
<span class="sd">            defines a parser using :py:func:`lib.tools.parser.add_switch`,</span>
<span class="sd">            so you need the arguments</span>

<span class="sd">            * name (str): name of the flag</span>
<span class="sd">            * description (str): description of what the flag does</span>
<span class="sd">            * short (optional): short name of the flag</span>

<span class="sd">    Returns:</span>
<span class="sd">        result of the argument parser</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">description</span><span class="o">=</span><span class="n">description</span><span class="p">)</span>

    <span class="c1"># Add Predefined arguments</span>
    <span class="k">if</span> <span class="n">list_arguments</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">dict_predefined_arguments</span> <span class="o">=</span> <span class="p">{</span>
            <span class="nb">tuple</span><span class="p">(</span><span class="n">dict_predefined_parse_args</span><span class="p">[</span><span class="n">arg_name</span><span class="p">][</span><span class="mi">0</span><span class="p">]):</span>
            <span class="n">dict_predefined_parse_args</span><span class="p">[</span><span class="n">arg_name</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">arg_name</span> <span class="ow">in</span> <span class="n">list_arguments</span>
        <span class="p">}</span>
        <span class="n">add_arguments_from_dict</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="n">dict_predefined_arguments</span><span class="p">)</span>

    <span class="c1"># Add new arguments</span>
    <span class="k">if</span> <span class="n">dict_arguments</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">add_arguments_from_dict</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="n">dict_arguments</span><span class="p">)</span>

    <span class="c1"># Add switches</span>
    <span class="k">if</span> <span class="n">switches</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">switches</span><span class="p">,</span> <span class="nb">dict</span><span class="p">):</span>
            <span class="n">switches</span> <span class="o">=</span> <span class="p">[</span><span class="n">switches</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">switch_kwargs</span> <span class="ow">in</span> <span class="n">switches</span><span class="p">:</span>
            <span class="n">add_switch</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="o">**</span><span class="n">switch_kwargs</span><span class="p">)</span>

    <span class="n">tuple_args</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="nb">vars</span><span class="p">(</span><span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">())</span><span class="o">.</span><span class="n">values</span><span class="p">())</span>
    <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">tuple_args</span><span class="p">)</span> <span class="o">&gt;=</span> <span class="mi">1</span>
    <span class="k">return</span> <span class="n">tuple_args</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">tuple_args</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="k">else</span> <span class="n">tuple_args</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>